
# Wrap inversion libraries and call them from Python using ctypes.

from ctypes import *

import sys
import inputFileParser

def olaRun(inputParms, outputDir, debug):

	error = c_int
	error = 1 #  c-code returns 0 for success; 
	try:
		libpath = sys.path[0] + '/lib/libola.so'
		libola = CDLL(libpath, mode=RTLD_GLOBAL)
		#libola = CDLL("lib/libola.so", mode=RTLD_GLOBAL)
		#libpars2.getInputFromFile.argtypes = [c_char_p, POINTER(InputParms)]
		#libpars2.getInputFromFile.restype = c_int
	
		libola.run.argtypes = [inputFileParser.InputParms, c_char_p, c_int]
		libola.run.restype = c_int
	
		error = c_int
		# error = libpars2.getInputFromFile(inputFileName, byref(myparms))
		#int run(InputParms inputParms, char *commandLineOutputDir, BOOLEAN debug)
		error = libola.run(inputParms, outputDir, debug)
		return error
	except RuntimeError as (errno, strerror):
		print "Error during OLA Inversion ({0}): {1}.".format(errno, strerror)
	except (OSError) as detail:
		print "OLA Inversions not installed, or there was a problem with the installation."
		print detail
		return error
		
def rlsRun(inputParms, outputDir, debug):

	error = c_int
	error = 1 #  c-code returns 0 for success; 
	try:
		libpath = sys.path[0] + '/lib/librls.so'
		librls = CDLL(libpath, mode=RTLD_GLOBAL)
		#librls = CDLL("lib/librls.so", mode=RTLD_GLOBAL)
		
		librls.run.argtypes = [inputFileParser.InputParms, c_char_p, c_int]
		librls.run.restype = c_int
		
		error = c_int
		error = librls.run(inputParms, outputDir, debug)
		return error
	except RuntimeError as (errno, strerror):
		print "Error during RLS Inversion ({0}): {1}.".format(errno, strerror)
	except (OSError) as detail:
		print "RLS Inversions not installed, or there was a problem with the installation."
		print detail
		return error
	
def lsqrRun(inputParms, outputDir, debug):

	error = c_int
	error = 1 #  c-code returns 0 for success; 
	try:
		libpath = sys.path[0] + '/lib/libolsqr.so'
		liblsqr = CDLL(libpath, mode=RTLD_GLOBAL)
		#liblsqr = CDLL("lib/libolsqr.so", mode=RTLD_GLOBAL)
		
		liblsqr.run.argtypes = [inputFileParser.InputParms, c_char_p, c_int]
		liblsqr.run.restype = c_int
		
		error = c_int
		error = liblsqr.run(inputParms, outputDir, debug)
		return error
	except (OSError) as detail:
		print "OLA LSQR Inversions not installed, or there was a problem with the installation."
		print detail
		return error

def clsqrRun(inputParms, outputDir, debug):

	error = c_int
	error = 1 #  c-code returns 0 for success; 
	try:
		libpath = sys.path[0] + '/lib/libolsqrc.so'
		libclsqr = CDLL(libpath, mode=RTLD_GLOBAL)
		#libclsqr = CDLL("lib/libolsqrc.so", mode=RTLD_GLOBAL)
                
		libclsqr.run.argtypes = [inputFileParser.InputParms, c_char_p, c_int]
		libclsqr.run.restype = c_int
                
		error = c_int
		error = libclsqr.run(inputParms, outputDir, debug)
		return error
	except (OSError) as detail:
		print "Constrained OLA LSQR Inversions not installed, or there was a problem with the installation."
		print detail
		return error

def forwardRun(inputParms, outputDir, debug):

	error = c_int
	error = 1 #  c-code returns 0 for success; 
	try:
		libpath = sys.path[0] + '/lib/libfwd.so'
		libfwd = CDLL(libpath, mode=RTLD_GLOBAL)
		#libfwd = CDLL("lib/libfwd.so", mode=RTLD_GLOBAL)
		
		libfwd.run.argtypes = [inputFileParser.InputParms, c_char_p, c_int]
		libfwd.run.restype = c_int
		
		error = c_int
		error = libfwd.run(inputParms, outputDir, debug)
		return error
	except RuntimeError as (errno, strerror):
		print "Error during forward calculation ({0}): {1}.".format(errno, strerror)
	except (OSError) as detail:
		print "Forward calculation not installed, or there was a problem with the installation."
		print detail
		return error

	


