/*
 * List.h
 *
 *  Created on: May 26, 2010
 *      Author: Brenda Javornik (e-mail: brendaj (at) cora.nwra.com)
 */

#ifndef LIST_H_
#define LIST_H_

/**
 *
 */


/**
 * Element of a linked list
 * @ingroup List
 */
struct node {
	char *content;		///< pointer to some data
	struct node *next;	///< pointer to next element in list
};

/**
 * Element of a linked list
 * @ingroup List
 */
typedef struct node Node;

/**
 * Head of linked list
 * @ingroup List
 */
struct head {
	Node *head;	///< pointer to first element in list
	int length;	///< length of the list; keep this value so we don't have to traverse the list to calculate it.
};

/**
 * Head of linked list
 * @ingroup List
 */
typedef struct head Head;

/** Iterator through a linked list. Operations
 * on the iterator take care of advancing
 * the pointers and checking for null pointers.
 * @ingroup List
 */
typedef Node **ListIterator;

/**
 * A list of items.
 * @ingroup List
 */
typedef Head *List;

List newList();
void freeList(List l);
void insertList( char *item, List l);
int getLengthList(List l);
ListIterator newListIterator(List l);
char *listIteratorNext(ListIterator li);
int endOfList(ListIterator li);

#endif /* LIST_H_ */
