/*
 * lambda.h
 *
 *  Created on: Apr 30, 2010
 *      Author: Brenda Javornik (e-mail: brendaj (at) cora.nwra.com)
 */

#ifndef LAMBDA_H_
#define LAMBDA_H_

/**
 * LambdaSet contains specifications for a range of lambda
 * values.
 * @ingroup LambdaSet
 */
typedef struct {
	double min; ///< minimum value
	double max; ///< maximum value
	int n; 		///< number of steps including min and max
	int log;	///< 0 if linear steps, != 0 if log steps
	double base;
	double mantissa;
} LambdaSet;

LambdaSet *newLambdaSet(double min, double max, int linearSteps, int logStep);

void freeLambdaSet(LambdaSet *ls);

double nextLambdaValue(LambdaSet lambdaSet, int n);

#endif /* LAMBDA_H_ */
