/*
 * InversionData.h
 *
 *  Created on: Nov 2, 2010
 *      Author: Brenda Javornik (e-mail: brendaj (at) cora.nwra.com)
 */

#ifndef INVERSIONDATA_H_
#define INVERSIONDATA_H_

#include "TempData.h"
#include "BaseDirectory.h"
#include "Model.h"
#include "InputData.h"
#include "lambda.h"

/** @defgroup InversionData Inversion Data
 * @{
 */

typedef struct {
	InputData *InputMatrices;
	TempData *IntermediateMatrices;
	LambdaSet parameter1;
	LambdaSet parameter2;
	int nthStepParm1;
	int nthStepParm2;
	double currentValueParm1;
	double currentValueParm2;
	Model *outputModel;
	BaseDirectory *outputBaseDir;
	BOOLEAN debug;
} InversionData;

/** @} */

#endif /* INVERSIONDATA_H_ */
